#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

//Struct usato per passare gli argomenti al thread
// abbiamo tre argomenti da passare ad un thread ma poi deve essere il main a stampare il risultato, la funzione che diamo in passo a un thread deve prendere e restituire un puntatore, per passare 3 argomenti a una cosa che ne prende uno deve mettere un puntatore ad una cosa che contiene più cose, per cui utilizziamo le struct 

// Args è il nome dello struct e dentro dichiariamo gli oggetti che abbiamo
struct Args{
  int* A;
  int* size;
  float* out;
};

//Funzione eseguita dal thread. La firma deve essere questa
void* media(void* args){
  
  int* A = ((struct Args*)args)->A;
  int* size = ((struct Args*)args)->size;
  float* out = ((struct Args*)args)->out;
  
  float sum = 0;
  int count = 0;
  
  for (int iii=0;iii<*size;++iii){
    sum += A[iii];
    ++count;
  }
  *out = sum / count;
}

int main(){
  int N= 10;
  
  //inizializzo A
  int A[N];
  for (int iii=0;iii<N;++iii){
    A[iii]=iii+1;
  }
  
  float mean=0;
  
  struct Args* args = (struct Args*) malloc(sizeof(struct Args*));
  args->A = A;
  args->size = &N;
  args->out = &mean;
  
  pthread_t t;
  pthread_create(&t, NULL, media, args);
  pthread_join(t, NULL);
  
  printf("Main thread: mean is %.2f\n",mean);
  
  free(args);
  
  return 0;
}
